diff -cprN head/src/backend/commands/tablecmds.c work/src/backend/commands/tablecmds.c
*** head/src/backend/commands/tablecmds.c	2010-01-18 09:26:23.915594000 +0900
--- work/src/backend/commands/tablecmds.c	2010-01-18 14:38:33.977063927 +0900
***************
*** 32,37 ****
--- 32,39 ----
  #include "catalog/pg_inherits_fn.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
+ #include "catalog/pg_operator.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_tablespace.h"
  #include "catalog/pg_trigger.h"
  #include "catalog/pg_type.h"
***************
*** 65,72 ****
--- 67,76 ----
  #include "storage/bufmgr.h"
  #include "storage/lmgr.h"
  #include "storage/smgr.h"
+ #include "tcop/utility.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
+ #include "utils/datum.h"
  #include "utils/fmgroids.h"
  #include "utils/inval.h"
  #include "utils/lsyscache.h"
*************** static void MergeAttributesIntoExisting(
*** 230,236 ****
  static void MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel);
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static void StoreCatalogInheritance1(Oid relationId, Oid parentOid,
! 						 int16 seqNumber, Relation inhRelation);
  static int	findAttrByName(const char *attributeName, List *schema);
  static void setRelhassubclassInRelation(Oid relationId, bool relhassubclass);
  static void AlterIndexNamespaces(Relation classRel, Relation rel,
--- 234,240 ----
  static void MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel);
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static void StoreCatalogInheritance1(Oid relationId, Oid parentOid,
! 					int16 seqNumber, ArrayType *inhvalues, Relation inhRelation);
  static int	findAttrByName(const char *attributeName, List *schema);
  static void setRelhassubclassInRelation(Oid relationId, bool relhassubclass);
  static void AlterIndexNamespaces(Relation classRel, Relation rel,
*************** static void ATExecEnableDisableRule(Rela
*** 331,340 ****
  						char fires_when);
  static void ATExecAddInherit(Relation rel, RangeVar *parent);
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  				   ForkNumber forkNum, bool istemp);
  static const char *storage_name(char c);
! 
  
  /* ----------------------------------------------------------------
   *		DefineRelation
--- 335,360 ----
  						char fires_when);
  static void ATExecAddInherit(Relation rel, RangeVar *parent);
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
+ static void ATExecPartitionBy(Relation rel, PartitionBy *defs);
+ static void ATExecAttachPartition(List **wqueue, AlteredTableInfo *tab, Relation rel, PartitionDef *def);
+ static void ATExecDetachPartition(Relation rel, RangeVar *child);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  				   ForkNumber forkNum, bool istemp);
  static const char *storage_name(char c);
! static void addInherit(Relation child_rel, Relation parent_rel,
! 					   List **wqueue, AlteredTableInfo *tab, PartitionDef *def);
! static void dropInherit(Relation rel, Relation parent_rel);
! static ArrayType *addPartitionConstraint(List **wqueue, AlteredTableInfo *tab,
! 		PartitionDef *def, Relation parent, Relation child);
! static void findRangePartition(Datum value, List *partitions, FmgrInfo *ltfn,
! 							   Partition **left, Partition **right);
! static Partition *findOverlappedListPartition(const Datum *values,
! 								int nvalues, List *partitions, FmgrInfo *eqfn);
! static List *gatherPartitionValues(List *partitions, Oid elmtype, int elmlen,
! 								   bool elmbyval);
! static Datum *evaluateValues(Oid typid, int typlen, bool typbyval,
! 							 List *values, int *length);
! static const char *getPartitionKindName(char partkind);
  
  /* ----------------------------------------------------------------
   *		DefineRelation
*************** StoreCatalogInheritance(Oid relationId, 
*** 1777,1783 ****
  	{
  		Oid			parentOid = lfirst_oid(entry);
  
! 		StoreCatalogInheritance1(relationId, parentOid, seqNumber, relation);
  		seqNumber++;
  	}
  
--- 1797,1803 ----
  	{
  		Oid			parentOid = lfirst_oid(entry);
  
! 		StoreCatalogInheritance1(relationId, parentOid, seqNumber, NULL, relation);
  		seqNumber++;
  	}
  
*************** StoreCatalogInheritance(Oid relationId, 
*** 1789,1796 ****
   * of parentOid.  inhRelation is the already-opened pg_inherits catalog.
   */
  static void
! StoreCatalogInheritance1(Oid relationId, Oid parentOid,
! 						 int16 seqNumber, Relation inhRelation)
  {
  	TupleDesc	desc = RelationGetDescr(inhRelation);
  	Datum		values[Natts_pg_inherits];
--- 1809,1816 ----
   * of parentOid.  inhRelation is the already-opened pg_inherits catalog.
   */
  static void
! StoreCatalogInheritance1(Oid relationId, Oid parentOid, int16 seqNumber,
! 						 ArrayType *inhvalues, Relation inhRelation)
  {
  	TupleDesc	desc = RelationGetDescr(inhRelation);
  	Datum		values[Natts_pg_inherits];
*************** StoreCatalogInheritance1(Oid relationId,
*** 1805,1812 ****
--- 1825,1834 ----
  	values[Anum_pg_inherits_inhrelid - 1] = ObjectIdGetDatum(relationId);
  	values[Anum_pg_inherits_inhparent - 1] = ObjectIdGetDatum(parentOid);
  	values[Anum_pg_inherits_inhseqno - 1] = Int16GetDatum(seqNumber);
+ 	values[Anum_pg_inherits_inhvalues - 1] = PointerGetDatum(inhvalues);
  
  	memset(nulls, 0, sizeof(nulls));
+ 	nulls[Anum_pg_inherits_inhvalues - 1] = (inhvalues == NULL);
  
  	tuple = heap_form_tuple(desc, values, nulls);
  
*************** RenameRelationInternal(Oid myrelid, cons
*** 2174,2179 ****
--- 2196,2220 ----
  }
  
  /*
+  * CREATE PARTITION partition ON table
+  */
+ void
+ CreatePartition(CreatePartitionStmt *stmt, const char *queryString)
+ {
+ 	List		   *stmts;
+ 	ListCell	   *cell;
+ 
+ 	stmts = transformCreatePartition(stmt->def, stmt->parent);
+ 
+ 	foreach(cell, stmts)
+ 	{
+ 		ProcessUtility((Node *) lfirst(cell),
+ 					   queryString, NULL, false, NULL, NULL);
+ 		CommandCounterIncrement();
+ 	}
+ }
+ 
+ /*
   * Disallow ALTER TABLE (and similar commands) when the current backend has
   * any open reference to the target table besides the one just acquired by
   * the calling command; this implies there's an open cursor or active plan.
*************** ATPrepCmd(List **wqueue, Relation rel, A
*** 2533,2543 ****
--- 2574,2590 ----
  		case AT_DisableRule:
  		case AT_AddInherit:		/* INHERIT / NO INHERIT */
  		case AT_DropInherit:
+ 		case AT_DetachPartition:	/* DETACH PARTITION */
  			ATSimplePermissions(rel, false);
  			/* These commands never recurse */
  			/* No command-specific prep needed */
  			pass = AT_PASS_MISC;
  			break;
+ 		case AT_PartitionBy:		/* PARTITION BY / NO PARTITION */
+ 		case AT_AttachPartition:	/* ATTACH PARTITION */
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_ADD_CONSTR;
+ 			break;
  		default:				/* oops */
  			elog(ERROR, "unrecognized alter table type: %d",
  				 (int) cmd->subtype);
*************** ATExecCmd(List **wqueue, AlteredTableInf
*** 2777,2782 ****
--- 2824,2838 ----
  		case AT_DropInherit:
  			ATExecDropInherit(rel, (RangeVar *) cmd->def);
  			break;
+ 		case AT_PartitionBy:	/* PARTITION BY / NO PARTITION */
+ 			ATExecPartitionBy(rel, (PartitionBy *) cmd->def);
+ 			break;
+ 		case AT_AttachPartition:
+ 			ATExecAttachPartition(wqueue, tab, rel, (PartitionDef *) cmd->def);
+ 			break;
+ 		case AT_DetachPartition:
+ 			ATExecDetachPartition(rel, (RangeVar *) cmd->def);
+ 			break;
  		default:				/* oops */
  			elog(ERROR, "unrecognized alter table type: %d",
  				 (int) cmd->subtype);
*************** ATExecAlterColumnType(AlteredTableInfo *
*** 6140,6145 ****
--- 6196,6208 ----
  					 getObjectDescription(&foundObject));
  				break;
  
+ 			case OCLASS_PARTITION:
+ 				/* TODO: recreate all partitions */
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 						 errmsg("cannot alter type of a column used in partition keys")));
+ 				break;
+ 
  			default:
  				elog(ERROR, "unrecognized object class: %u",
  					 foundObject.classId);
*************** ATExecEnableDisableRule(Relation rel, ch
*** 7107,7113 ****
  }
  
  /*
!  * ALTER TABLE INHERIT
   *
   * Add a parent to the child's parents. This verifies that all the columns and
   * check constraints of the parent appear in the child and that they have the
--- 7170,7176 ----
  }
  
  /*
!  * ALTER TABLE INHERIT / ATTACH PARTITION
   *
   * Add a parent to the child's parents. This verifies that all the columns and
   * check constraints of the parent appear in the child and that they have the
*************** ATExecEnableDisableRule(Relation rel, ch
*** 7116,7128 ****
  static void
  ATExecAddInherit(Relation child_rel, RangeVar *parent)
  {
! 	Relation	parent_rel,
! 				catalogRelation;
! 	SysScanDesc scan;
! 	ScanKeyData key;
! 	HeapTuple	inheritsTuple;
! 	int32		inhseqno;
! 	List	   *children;
  
  	/*
  	 * AccessShareLock on the parent is what's obtained during normal CREATE
--- 7179,7185 ----
  static void
  ATExecAddInherit(Relation child_rel, RangeVar *parent)
  {
! 	Relation	parent_rel;
  
  	/*
  	 * AccessShareLock on the parent is what's obtained during normal CREATE
*************** ATExecAddInherit(Relation child_rel, Ran
*** 7130,7135 ****
--- 7187,7228 ----
  	 */
  	parent_rel = heap_openrv(parent, AccessShareLock);
  
+ 	addInherit(child_rel, parent_rel, NULL, NULL, NULL);
+ 
+ 	/* keep our lock on the parent relation until commit */
+ 	heap_close(parent_rel, NoLock);
+ }
+ 
+ static void
+ ATExecAttachPartition(List **wqueue, AlteredTableInfo *tab,
+ 					  Relation parent_rel, PartitionDef *def)
+ {
+ 	Relation	child_rel;
+ 
+ 	/*
+ 	 * AccessShareLock on the parent is what's obtained during normal CREATE
+ 	 * TABLE ... INHERITS ..., so should be enough here.
+ 	 */
+ 	child_rel = heap_openrv(def->name, AccessShareLock);
+ 
+ 	addInherit(child_rel, parent_rel, wqueue, tab, def);
+ 
+ 	/* keep our lock on the parent relation until commit */
+ 	heap_close(child_rel, NoLock);
+ }
+ 
+ static void
+ addInherit(Relation child_rel, Relation parent_rel,
+ 		   List **wqueue, AlteredTableInfo *tab, PartitionDef *def)
+ {
+ 	Relation	catalogRelation;
+ 	SysScanDesc scan;
+ 	ScanKeyData key;
+ 	HeapTuple	inheritsTuple;
+ 	int32		inhseqno;
+ 	List	   *children;
+ 	ArrayType  *inhvalues;
+ 
  	/*
  	 * Must be owner of both parent and child -- child was checked by
  	 * ATSimplePermissions call in ATPrepCmd
*************** ATExecAddInherit(Relation child_rel, Ran
*** 7197,7203 ****
  				(errcode(ERRCODE_DUPLICATE_TABLE),
  				 errmsg("circular inheritance not allowed"),
  				 errdetail("\"%s\" is already a child of \"%s\".",
! 						   parent->relname,
  						   RelationGetRelationName(child_rel))));
  
  	/* If parent has OIDs then child must have OIDs */
--- 7290,7296 ----
  				(errcode(ERRCODE_DUPLICATE_TABLE),
  				 errmsg("circular inheritance not allowed"),
  				 errdetail("\"%s\" is already a child of \"%s\".",
! 						   RelationGetRelationName(parent_rel),
  						   RelationGetRelationName(child_rel))));
  
  	/* If parent has OIDs then child must have OIDs */
*************** ATExecAddInherit(Relation child_rel, Ran
*** 7214,7232 ****
  	/* Match up the constraints and bump coninhcount as needed */
  	MergeConstraintsIntoExisting(child_rel, parent_rel);
  
  	/*
  	 * OK, it looks valid.	Make the catalog entries that show inheritance.
  	 */
  	StoreCatalogInheritance1(RelationGetRelid(child_rel),
  							 RelationGetRelid(parent_rel),
  							 inhseqno + 1,
  							 catalogRelation);
  
  	/* Now we're done with pg_inherits */
  	heap_close(catalogRelation, RowExclusiveLock);
  
! 	/* keep our lock on the parent relation until commit */
! 	heap_close(parent_rel, NoLock);
  }
  
  /*
--- 7307,7732 ----
  	/* Match up the constraints and bump coninhcount as needed */
  	MergeConstraintsIntoExisting(child_rel, parent_rel);
  
+ 	/* Add CHECK constraint for partition */
+ 	if (def != NULL)
+ 		inhvalues = addPartitionConstraint(
+ 							wqueue, tab, def, parent_rel, child_rel);
+ 	else
+ 		inhvalues = NULL;
+ 
  	/*
  	 * OK, it looks valid.	Make the catalog entries that show inheritance.
  	 */
  	StoreCatalogInheritance1(RelationGetRelid(child_rel),
  							 RelationGetRelid(parent_rel),
  							 inhseqno + 1,
+ 							 inhvalues,
  							 catalogRelation);
  
  	/* Now we're done with pg_inherits */
  	heap_close(catalogRelation, RowExclusiveLock);
+ }
  
! /*
!  * addPartitionConstraint - Add check constraint for partition.
!  */
! static ArrayType *
! addPartitionConstraint(List **wqueue, AlteredTableInfo *tab, PartitionDef *def,
! 					   Relation parent, Relation child)
! {
! 	HeapTuple		tp;
! 	Form_pg_opclass	opclassTup;
! 	char			partkind;
! 	Node		   *partkey;
! 	Oid				opclass;
! 	Oid				opfamily;
! 	Oid				opcintype;
! 	List		   *partitions;
! 	Oid				elmtype;
! 	int16			elmlen;
! 	bool			elmbyval;
! 	char			elmalign;
! 	int16			strategy;
! 	Oid				oprid;
! 	List		   *opr;
! 	FmgrInfo		opfn;
! 	Node		   *check_expr;
! 	Datum		   *values;
! 	int				nvalues;
! 
! 	/* Retrieve partition information. */
! 	partitions = get_partitions(RelationGetRelid(parent),
! 								&partkind, &partkey, &opclass);
! 	if (partkind == 0)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 				 errmsg("table \"%s\" is not partitioned",
! 						RelationGetRelationName(parent))));
! 	if (partkind != def->kind)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 				 errmsg("cannot add %s partition \"%s\" to %s partitioned table \"%s\"",
! 						getPartitionKindName(def->kind),
! 						RelationGetRelationName(child),
! 						getPartitionKindName(partkind),
! 						RelationGetRelationName(parent))));
! 
! 	/* Check for duplicated overflow partitions */
! 	if (list_length(partitions) > 0 && 
! 		((Partition *) llast(partitions))->nvalues == 0)
! 	{
! 		if (def->values == NIL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_DUPLICATE_TABLE),
! 					 errmsg("duplicated overflow partition")));
! 		else
! 			ereport(ERROR,
! 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("cannot add partition to \"%s\", that has an overflow partition",
! 							RelationGetRelationName(parent))));
! 	}
! 
! 	/* Retrieve type information and convert expressions into datum array. */
! 	elmtype = exprType(partkey);
! 	get_typlenbyvalalign(elmtype, &elmlen, &elmbyval, &elmalign);
! 	values = evaluateValues(elmtype, elmlen, elmbyval, def->values, &nvalues);
! 
! 	/* Retrieve operator information. */
! 	tp = SearchSysCache(CLAOID, ObjectIdGetDatum(opclass), 0, 0, 0);
! 	if (!HeapTupleIsValid(tp))
! 		elog(ERROR, "cache lookup failed for opclass %u", opclass);
! 	opclassTup = (Form_pg_opclass) GETSTRUCT(tp);
! 	opfamily = opclassTup->opcfamily;
! 	opcintype = opclassTup->opcintype;
! 	ReleaseSysCache(tp);
! 
! 	if (!OidIsValid(opcintype))
! 		opcintype = elmtype;
! 
! 	switch (partkind)
! 	{
! 		case PARTITION_BY_RANGE:
! 			strategy = BTLessStrategyNumber;
! 			break;
! 		case PARTITION_BY_LIST:
! 			strategy = BTEqualStrategyNumber;
! 			break;
! 		default:
! 			strategy = 0;
! 	}
! 	oprid = get_opfamily_member(opfamily, opcintype, opcintype, strategy);
! 	if (!OidIsValid(oprid))
! 		elog(ERROR, "missing operator %d(%u,%u) in opfamily %u",
! 			 strategy, opcintype, opcintype, opfamily);
! 	opr = get_opfullname(oprid);
! 	fmgr_info(get_opcode(oprid), &opfn);
! 
! 	/* ALTER TABLE ... ADD CHECK */
! 	switch (partkind)
! 	{
! 		case PARTITION_BY_RANGE:
! 		{
! 			Partition  *left;
! 			Partition  *right;
! 			Node	   *lt = NULL;
! 			Node	   *ge = NULL;
! 
! 			/* Check for overlapped list partition values. */
! 			if (nvalues > 0)
! 			{
! 				Assert(nvalues == 1);
! 				lt = (Node *) makeA_Expr(
! 					AEXPR_OP, opr, partkey, linitial(def->values), -1);
! 				findRangePartition(values[0], partitions, &opfn, &left, &right);
! 			}
! 			else
! 			{
! 				left = (list_length(partitions) > 0 ? llast(partitions) : NULL);
! 				right = NULL;
! 			}
! 
! 			/* TODO: split overlapped partition */
! 			if (right != NULL)
! 				ereport(ERROR,
! 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 						 errmsg("cannot split partition \"%s\"",
! 								get_rel_name(right->relid))));
! 
! 			if (left)
! 			{
! 				Oid		oprle;
! 				Node   *lower;
! 				
! 				oprle = get_opfamily_member(opfamily, opcintype, opcintype,
! 											BTLessEqualStrategyNumber);
! 				if (!OidIsValid(oprid))
! 					elog(ERROR, "missing operator %d(%u,%u) in opfamily %u",
! 						 BTLessEqualStrategyNumber, opcintype, opcintype, opfamily);
! 				lower = (Node *) makeConst(elmtype, -1, elmlen, left->values[0],
! 										   false, elmbyval);
! 				/* lower <= key */
! 				ge = (Node *) makeA_Expr(AEXPR_OP, get_opfullname(oprle),
! 										 lower, partkey, -1);
! 			}
! 
! 			if (ge == NULL)			/* key < upper */
! 				check_expr = lt;
! 			else if (lt == NULL)	/* key >= lower */
! 				check_expr = ge;
! 			else					/* key >= lower AND key < upper */
! 				check_expr = (Node *) makeA_Expr(AEXPR_AND, NIL, ge, lt, -1);
! 			break;
! 		}
! 		case PARTITION_BY_LIST:
! 		{
! 			if (nvalues > 0)
! 			{
! 				Partition *overlapped;
! 
! 				/* Check for overlapped list partition values. */
! 				overlapped = findOverlappedListPartition(values, nvalues,
! 														 partitions, &opfn);
! 
! 				/* TODO: split overlapped partition */
! 				if (overlapped != NULL)
! 					ereport(ERROR,
! 							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 							errmsg("partition values overlapped with \"%s\"",
! 								get_rel_name(overlapped->relid))));
! 
! 				/* CHECK ( key = ANY ( values ) ) */
! 				check_expr = (Node *) makeA_Expr(AEXPR_IN, opr, partkey,
! 												 (Node *) def->values, -1);
! 			}
! 			else
! 			{
! 				List *all_values = gatherPartitionValues(partitions, elmtype,
! 														 elmlen, elmbyval);
! 
! 				/* CHECK ( NOT (key = ANY ( values ) ) ) */
! 				if (all_values == NIL)
! 					check_expr = NULL;
! 				else
! 					check_expr = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
! 									(Node *) makeA_Expr(AEXPR_IN, opr, partkey,
! 										(Node *) all_values, -1), -1);
! 			}
! 
! 			break;
! 		}
! 		default:
! 			elog(ERROR, "unknown partition kind: %d", partkind);
! 			check_expr = NULL;	/* keep compiler quiet */
! 	}
! 
! 	/* Add partition constraint if there are no same check constraint. */
! 	if (check_expr != NULL)
! 	{
! 		TupleConstr	   *constr;
! 		Node		   *cooked_expr = NULL;
! 		bool			found = false;
! 
! 		if ((constr = RelationGetDescr(child)->constr) != NULL)
! 		{
! 			ParseState	   *pstate;
! 			RangeTblEntry  *rte;
! 			int				i;
! 
! 			pstate = make_parsestate(NULL);
! 			rte = addRangeTableEntryForRelation(pstate, child, NULL, false, true);
! 			addRTEtoQuery(pstate, rte, true, true, true);
! 			cooked_expr = cookConstraint(pstate, check_expr,
! 										 RelationGetRelationName(child));
! 			free_parsestate(pstate);
! 
! 			for (i = 0; i < constr->num_check; i++)
! 			{
! 				if (equal(cooked_expr, stringToNode(constr->check[i].ccbin)))
! 				{
! 					found = true;
! 					break;
! 				}
! 			}
! 		}
! 
! 		/* Add a new check constraint only when not found. */
! 		if (!found)
! 		{
! 			Constraint	   *check;
! 
! 			check = makeNode(Constraint);
! 			check->contype = CONSTR_CHECK;
! 			check->location = -1;
! 			check->raw_expr = (cooked_expr ? NULL : check_expr);
! 			check->cooked_expr = (cooked_expr ? nodeToString(cooked_expr) : NULL);
! 			ATAddCheckConstraint(wqueue, tab, child, check, false, false);
! 		}
! 	}
! 
! 	/* overflow partition has an empty array. */
! 	return construct_array(values, nvalues, elmtype, elmlen, elmbyval, elmalign);
! }
! 
! /*
!  * Return left and right range partitions.
!  */
! static void
! findRangePartition(Datum value, List *partitions, FmgrInfo *ltfn,
! 				   Partition **left, Partition **right)
! {
! 	ListCell		   *cell;
! 
! 	Assert(left != NULL);
! 	Assert(right != NULL);
! 
! 	*left = *right = NULL;
! 
! 	foreach(cell, partitions)
! 	{
! 		Partition *p = (Partition *) lfirst(cell);
! 
! 		if (p->nvalues > 0 &&
! 			DatumGetBool(FunctionCall2(ltfn, p->values[0], value)))
! 		{
! 			/* left < p < value */
! 			if (*left == NULL || DatumGetBool(FunctionCall2(ltfn,
! 									(*left)->values[0], p->values[0])))
! 				*left = p;
! 		}
! 		else
! 		{
! 			/* value <= p < right */
! 			if (*right == NULL || (*right)->nvalues == 0 ||
! 				(p->nvalues > 0 && DatumGetBool(FunctionCall2(ltfn,
! 										p->values[0], (*right)->values[0]))))
! 				*right = p;
! 		}
! 	}
! }
! 
! /*
!  * Return an overlapped list partition, or NULL if not found.
!  */
! static Partition *
! findOverlappedListPartition(const Datum *values, int nvalues,
! 							List *partitions, FmgrInfo *eqfn)
! {
! 	ListCell   *cell;
! 	int			i;
! 	int			j;
! 
! 	foreach(cell, partitions)
! 	{
! 		Partition *p = (Partition *) lfirst(cell);
! 
! 		for (i = 0; i < p->nvalues; i++)
! 			for (j = 0; j < nvalues; j++)
! 				if (DatumGetBool(FunctionCall2(eqfn, p->values[i], values[j])))
! 					return p;
! 	}
! 
! 	return NULL;
! }
! 
! /*
!  * Gather partition values as a list of Const nodes.
!  */
! static List *
! gatherPartitionValues(List *partitions, Oid elmtype, int elmlen, bool elmbyval)
! {
! 	List	   *all_values = NIL;
! 	ListCell   *cell;
! 	int			i;
! 
! 	foreach(cell, partitions)
! 	{
! 		Partition *p = (Partition *) lfirst(cell);
! 
! 		for (i = 0; i < p->nvalues; i++)
! 		{
! 			Const *value = makeConst(elmtype, -1, elmlen,
! 				p->values[i], false, elmbyval);
! 			all_values = lappend(all_values, value);
! 		}
! 	}
! 
! 	return all_values;
! }
! 
! /*
!  * evaluateValues - evaluate a list of expressions to build a datum array.
!  */
! static Datum *
! evaluateValues(Oid typid, int typlen, bool typbyval, List *values, int *length)
! {
! 	ListCell	   *cell;
! 	ParseState	   *pstate;
! 	EState		   *estate;
! 	ExprContext	   *econtext;
! 	int				i;
! 	Datum		   *datum;
! 
! 	*length = list_length(values);
! 	if (*length < 1)
! 		return NULL;
! 
! 	datum = (Datum *) palloc(*length * sizeof(Datum));
! 	pstate = make_parsestate(NULL);
! 	estate = CreateExecutorState();
! 	econtext = GetPerTupleExprContext(estate);
! 
! 	i = 0;
! 	foreach(cell, values)
! 	{
! 		Node		   *value = (Node *) lfirst(cell);
! 		bool			isnull;
! 		ExprState	   *expr;
! 		MemoryContext	oldcxt;
! 
! 		oldcxt = MemoryContextSwitchTo(GetPerTupleMemoryContext(estate));
! 
! 		value = transformExpr(pstate, value);
! 		value = coerce_to_specific_type(pstate, value, typid, "PARTITION");
! 		expr = ExecPrepareExpr((Expr *) value, estate);
! 
! 		datum[i] = ExecEvalExpr(expr, econtext, &isnull, NULL);
! 		if (isnull)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 					 errmsg("partition key must not be NULL")));
! 
! 		MemoryContextSwitchTo(oldcxt);
! 
! 		if (!typbyval)
! 		{
! 			if (typlen == -1)
! 				datum[i] = PointerGetDatum(PG_DETOAST_DATUM_COPY(datum[i]));
! 			else
! 				datum[i] = datumCopy(datum[i], false, typlen);
! 		}
! 
! 		ResetPerTupleExprContext(estate);
! 		i++;
! 	}
! 
! 	FreeExecutorState(estate);
! 	free_parsestate(pstate);
! 
! 	return datum;
! }
! 
! static const char *
! getPartitionKindName(char partkind)
! {
! 	switch (partkind)
! 	{
! 		case PARTITION_BY_RANGE:
! 			return "RANGE";
! 		case PARTITION_BY_LIST:
! 			return "LIST";
! 		default:
! 			return "???";
! 	}
  }
  
  /*
*************** MergeConstraintsIntoExisting(Relation ch
*** 7459,7465 ****
  }
  
  /*
!  * ALTER TABLE NO INHERIT
   *
   * Drop a parent from the child's parents. This just adjusts the attinhcount
   * and attislocal of the columns and removes the pg_inherit and pg_depend
--- 7959,7965 ----
  }
  
  /*
!  * ALTER TABLE NO INHERIT / DETACH PARTITION
   *
   * Drop a parent from the child's parents. This just adjusts the attinhcount
   * and attislocal of the columns and removes the pg_inherit and pg_depend
*************** static void
*** 7478,7483 ****
--- 7978,8013 ----
  ATExecDropInherit(Relation rel, RangeVar *parent)
  {
  	Relation	parent_rel;
+ 
+ 	/*
+ 	 * AccessShareLock on the parent is probably enough, seeing that DROP
+ 	 * TABLE doesn't lock parent tables at all.  We need some lock since we'll
+ 	 * be inspecting the parent's schema.
+ 	 */
+ 	parent_rel = heap_openrv(parent, AccessShareLock);
+ 
+ 	dropInherit(rel, parent_rel);
+ 
+ 	/* close rel, but keep lock until commit */
+ 	relation_close(parent_rel, NoLock);
+ }
+ 
+ static void
+ ATExecDetachPartition(Relation rel, RangeVar *child)
+ {
+ 	Relation	child_rel;
+ 
+ 	child_rel = heap_openrv(child, AccessExclusiveLock);
+ 
+ 	dropInherit(child_rel, rel);
+ 
+ 	/* close rel, but keep lock until commit */
+ 	relation_close(child_rel, NoLock);
+ }
+ 
+ static void
+ dropInherit(Relation rel, Relation parent_rel)
+ {
  	Relation	catalogRelation;
  	SysScanDesc scan;
  	ScanKeyData key[3];
*************** ATExecDropInherit(Relation rel, RangeVar
*** 7489,7501 ****
  	bool		found = false;
  
  	/*
- 	 * AccessShareLock on the parent is probably enough, seeing that DROP
- 	 * TABLE doesn't lock parent tables at all.  We need some lock since we'll
- 	 * be inspecting the parent's schema.
- 	 */
- 	parent_rel = heap_openrv(parent, AccessShareLock);
- 
- 	/*
  	 * We don't bother to check ownership of the parent table --- ownership of
  	 * the child is presumed enough rights.
  	 */
--- 8019,8024 ----
*************** ATExecDropInherit(Relation rel, RangeVar
*** 7686,7694 ****
  
  	systable_endscan(scan);
  	heap_close(catalogRelation, RowExclusiveLock);
  
! 	/* keep our lock on the parent relation until commit */
! 	heap_close(parent_rel, NoLock);
  }
  
  
--- 8209,8309 ----
  
  	systable_endscan(scan);
  	heap_close(catalogRelation, RowExclusiveLock);
+ }
  
! 
! /*
!  * ALTER TABLE PARTITION BY / NO PARTITION
!  */
! static void
! ATExecPartitionBy(Relation rel, PartitionBy *defs)
! {
! 	Oid				relid = RelationGetRelid(rel);
! 	HeapTuple		tp;
! 	ObjectAddress	myself;
! 
! 	tp = SearchSysCache(PARTITIONKEY, ObjectIdGetDatum(relid), 0, 0, 0);
! 	if (HeapTupleIsValid(tp))
! 	{
! 		if (defs != NULL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 			 errmsg("multiple partition keys for table \"%s\" are not allowed",
! 					RelationGetRelationName(rel))));
! 		ReleaseSysCache(tp);
! 	}
! 	else if (defs == NULL)
! 	{
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 				 errmsg("table \"%s\" has no partition key",
! 					RelationGetRelationName(rel))));
! 	}
! 
! 	myself.classId = PartitionRelationId;
! 	myself.objectId = relid;
! 	myself.objectSubId = 0;
! 
! 	if (defs == NULL)
! 	{
! 		/* ALTER TABLE <name> NO PARTITION */
! 		performDeletion(&myself, DROP_RESTRICT);
! 	}
! 	else
! 	{
! 		/* ALTER TABLE <name> PARTITION BY ... */
! 		Relation		catalogRel;
! 		TupleDesc		catalogDesc;
! 		Datum			datum[Natts_pg_partition];
! 		bool			nulls[Natts_pg_partition];
! 		HeapTuple		tuple;
! 		Node		   *partkey;
! 		Oid				keytype;
! 		Oid				opclass;
! 		ParseState	   *pstate;
! 		RangeTblEntry  *rte;
! 		ObjectAddress	opclassObject;
! 
! 		Assert(defs->key != NULL);
! 
! 		/* Transform the expression of partition key. */
! 		pstate = make_parsestate(NULL);
! 		rte = addRangeTableEntryForRelation(pstate, rel, NULL, false, true);
! 		addRTEtoQuery(pstate, rte, true, true, true);
! 		partkey = transformExpr(pstate, defs->key);
! 		free_parsestate(pstate);
! 
! 		/* Extract operator oid to compare partition keys */
! 		keytype = exprType(partkey);
! 		opclass = GetIndexOpClass(defs->opclass, keytype, "btree", BTREE_AM_OID);
! 
! 		/*
! 		 * Make the pg_partition entry
! 		 */
! 		memset(nulls, 0, sizeof(nulls));
! 		datum[0] = ObjectIdGetDatum(relid);			/* partrelid */
! 		datum[1] = ObjectIdGetDatum(opclass);		/* partopclass */
! 		datum[2] = CharGetDatum(defs->kind);		/* partkind */
! 		datum[3] = CStringGetTextDatum(nodeToString(partkey));	/* partkey */
! 
! 		catalogRel = heap_open(PartitionRelationId, RowExclusiveLock);
! 		catalogDesc = RelationGetDescr(catalogRel);
! 
! 		tuple = heap_form_tuple(catalogDesc, datum, nulls);
! 		simple_heap_insert(catalogRel, tuple);
! 		CatalogUpdateIndexes(catalogRel, tuple);
! 		heap_freetuple(tuple);
! 
! 		/* Store a dependency */
! 		recordDependencyOnSingleRelExpr(&myself, partkey, relid,
! 										DEPENDENCY_NORMAL, DEPENDENCY_AUTO);
! 		opclassObject.classId = OperatorClassRelationId;
! 		opclassObject.objectId = opclass;
! 		opclassObject.objectSubId = 0;
! 		recordDependencyOn(&myself, &opclassObject, DEPENDENCY_NORMAL);
! 
! 		heap_close(catalogRel, RowExclusiveLock);
! 	}
  }
  
  
diff -cprN head/src/backend/nodes/copyfuncs.c work/src/backend/nodes/copyfuncs.c
*** head/src/backend/nodes/copyfuncs.c	2010-01-06 09:46:25.748744000 +0900
--- work/src/backend/nodes/copyfuncs.c	2010-01-18 14:38:33.979469788 +0900
*************** _copyCreateStmt(CreateStmt *from)
*** 2511,2516 ****
--- 2511,2517 ----
  	COPY_NODE_FIELD(options);
  	COPY_SCALAR_FIELD(oncommit);
  	COPY_STRING_FIELD(tablespacename);
+ 	COPY_NODE_FIELD(partitions);
  
  	return newnode;
  }
*************** _copyAlterTSConfigurationStmt(AlterTSCon
*** 3469,3474 ****
--- 3470,3513 ----
  	return newnode;
  }
  
+ static PartitionDef *
+ _copyPartitionDef(PartitionDef *from)
+ {
+ 	PartitionDef *newnode = makeNode(PartitionDef);
+ 
+ 	COPY_SCALAR_FIELD(kind);
+ 	COPY_NODE_FIELD(name);
+ 	COPY_NODE_FIELD(values);
+ 	COPY_NODE_FIELD(options);
+ 	COPY_STRING_FIELD(tablespacename);
+ 
+ 	return newnode;
+ }
+ 
+ static PartitionBy *
+ _copyPartitionBy(PartitionBy *from)
+ {
+ 	PartitionBy *newnode = makeNode(PartitionBy);
+ 
+ 	COPY_SCALAR_FIELD(kind);
+ 	COPY_NODE_FIELD(key);
+ 	COPY_NODE_FIELD(opclass);
+ 	COPY_NODE_FIELD(defs);
+ 
+ 	return newnode;
+ }
+ 
+ static CreatePartitionStmt *
+ _copyCreatePartitionStmt(CreatePartitionStmt *from)
+ {
+ 	CreatePartitionStmt *newnode = makeNode(CreatePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(parent);
+ 	COPY_NODE_FIELD(def);
+ 
+ 	return newnode;
+ }
+ 
  /* ****************************************************************
   *					pg_list.h copy functions
   * ****************************************************************
*************** copyObject(void *from)
*** 4139,4144 ****
--- 4178,4192 ----
  		case T_AlterTSConfigurationStmt:
  			retval = _copyAlterTSConfigurationStmt(from);
  			break;
+ 		case T_PartitionDef:
+ 			retval = _copyPartitionDef(from);
+ 			break;
+ 		case T_PartitionBy:
+ 			retval = _copyPartitionBy(from);
+ 			break;
+ 		case T_CreatePartitionStmt:
+ 			retval = _copyCreatePartitionStmt(from);
+ 			break;
  
  		case T_A_Expr:
  			retval = _copyAExpr(from);
